diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/energy/bindings/modulegen__gcc_LP64.py ns-3.33/src/energy/bindings/modulegen__gcc_LP64.py
--- ns-3.32/src/energy/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/energy/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
@@ -5216,42 +5231,42 @@
     cls.add_method('GetAddress', 
                    'ns3::Address', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): ns3::Address ns3::NetDevice::GetBroadcast() const [member function]
     cls.add_method('GetBroadcast', 
                    'ns3::Address', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): ns3::Ptr<ns3::Channel> ns3::NetDevice::GetChannel() const [member function]
     cls.add_method('GetChannel', 
                    'ns3::Ptr< ns3::Channel >', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): uint32_t ns3::NetDevice::GetIfIndex() const [member function]
     cls.add_method('GetIfIndex', 
                    'uint32_t', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): uint16_t ns3::NetDevice::GetMtu() const [member function]
     cls.add_method('GetMtu', 
                    'uint16_t', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): ns3::Address ns3::NetDevice::GetMulticast(ns3::Ipv4Address multicastGroup) const [member function]
     cls.add_method('GetMulticast', 
                    'ns3::Address', 
                    [param('ns3::Ipv4Address', 'multicastGroup')], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): ns3::Address ns3::NetDevice::GetMulticast(ns3::Ipv6Address addr) const [member function]
     cls.add_method('GetMulticast', 
                    'ns3::Address', 
                    [param('ns3::Ipv6Address', 'addr')], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): ns3::Ptr<ns3::Node> ns3::NetDevice::GetNode() const [member function]
     cls.add_method('GetNode', 
                    'ns3::Ptr< ns3::Node >', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): static ns3::TypeId ns3::NetDevice::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
                    'ns3::TypeId', 
@@ -5261,32 +5276,32 @@
     cls.add_method('IsBridge', 
                    'bool', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): bool ns3::NetDevice::IsBroadcast() const [member function]
     cls.add_method('IsBroadcast', 
                    'bool', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): bool ns3::NetDevice::IsLinkUp() const [member function]
     cls.add_method('IsLinkUp', 
                    'bool', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): bool ns3::NetDevice::IsMulticast() const [member function]
     cls.add_method('IsMulticast', 
                    'bool', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): bool ns3::NetDevice::IsPointToPoint() const [member function]
     cls.add_method('IsPointToPoint', 
                    'bool', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): bool ns3::NetDevice::NeedsArp() const [member function]
     cls.add_method('NeedsArp', 
                    'bool', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## net-device.h (module 'network'): bool ns3::NetDevice::Send(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
     cls.add_method('Send', 
                    'bool', 
@@ -5331,7 +5346,7 @@
     cls.add_method('SupportsSendFrom', 
                    'bool', 
                    [], 
-                   is_pure_virtual=True, is_const=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3NixVector_methods(root_module, cls):
@@ -6240,7 +6255,7 @@
     cls.add_method('operator()', 
                    'ns3::ObjectBase *', 
                    [], 
-                   is_pure_virtual=True, is_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Double_Double_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6262,7 +6277,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('double', 'arg0'), param('double', 'arg1')], 
-                   is_pure_virtual=True, is_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6284,7 +6299,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3'), param('ns3::Address const &', 'arg4'), param('ns3::NetDevice::PacketType', 'arg5')], 
-                   is_pure_virtual=True, is_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6306,7 +6321,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0')], 
-                   is_pure_virtual=True, is_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Time_Ns3Time_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6328,7 +6343,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Time', 'arg0'), param('ns3::Time', 'arg1')], 
-                   is_pure_virtual=True, is_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/energy/examples/basic-energy-model-test.cc ns-3.33/src/energy/examples/basic-energy-model-test.cc
--- ns-3.32/src/energy/examples/basic-energy-model-test.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/energy/examples/basic-energy-model-test.cc	2021-01-09 10:19:22.000000000 -0800
@@ -357,7 +357,7 @@
   WifiHelper wifi;
   wifi.SetStandard (WIFI_STANDARD_80211b);
 
-  YansWifiPhyHelper wifiPhy = YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper wifiPhy;
   /*
    * This is one parameter that matters when using FixedRssLossModel, set it to
    * zero; otherwise, gain will be added.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/energy/examples/li-ion-energy-source.cc ns-3.33/src/energy/examples/li-ion-energy-source.cc
--- ns-3.32/src/energy/examples/li-ion-energy-source.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/energy/examples/li-ion-energy-source.cc	2021-01-09 10:19:22.000000000 -0800
@@ -47,7 +47,7 @@
 static void
 PrintCellInfo (Ptr<LiIonEnergySource> es)
 {
-  std::cout << "At " << Simulator::Now ().GetSeconds () << " Cell voltage: " << es->GetSupplyVoltage () << " V Remaining Capacity: " <<
+  std::cout << "At " << Simulator::Now ().As (Time::S) << " Cell voltage: " << es->GetSupplyVoltage () << " V Remaining Capacity: " <<
   es->GetRemainingEnergy () / (3.6 * 3600) << " Ah" << std::endl;
 
   if (!Simulator::IsFinished ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/energy/examples/rv-battery-model-test.cc ns-3.33/src/energy/examples/rv-battery-model-test.cc
--- ns-3.32/src/energy/examples/rv-battery-model-test.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/energy/examples/rv-battery-model-test.cc	2021-01-09 10:19:22.000000000 -0800
@@ -734,7 +734,7 @@
   WifiHelper wifi;
   wifi.SetStandard (WIFI_STANDARD_80211b);
 
-  YansWifiPhyHelper wifiPhy =  YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper wifiPhy;
   /*
    * This is one parameter that matters when using FixedRssLossModel, set it to
    * zero; otherwise, gain will be added.
@@ -780,8 +780,8 @@
   Ptr<RvBatteryModel> srcPtr = DynamicCast<RvBatteryModel> (sources.Get (0));
   actualLifetime = srcPtr->GetLifetime ();
 
-  NS_LOG_DEBUG ("Expected lifetime = " << expLifetime.GetSeconds () << "s");
-  NS_LOG_DEBUG ("Actual lifetime = " << actualLifetime.GetSeconds () << "s");
+  NS_LOG_DEBUG ("Expected lifetime = " << expLifetime.As (Time::S));
+  NS_LOG_DEBUG ("Actual lifetime = " << actualLifetime.As (Time::S));
 
   Simulator::Destroy ();
 
@@ -821,7 +821,7 @@
   WifiHelper wifi;
   wifi.SetStandard (WIFI_STANDARD_80211b);
 
-  YansWifiPhyHelper wifiPhy =  YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper wifiPhy;
   /*
    * This is one parameter that matters when using FixedRssLossModel, set it to
    * zero; otherwise, gain will be added.
@@ -876,15 +876,14 @@
   Ptr<RvBatteryModel> srcPtr = DynamicCast<RvBatteryModel> (sources.Get (0));
   actualLifetime = srcPtr->GetLifetime ();
 
-  NS_LOG_DEBUG ("Expected lifetime = " << expLifetime.GetSeconds () << "s");
-  NS_LOG_DEBUG ("Actual lifetime = " << actualLifetime.GetSeconds () << "s");
-  NS_LOG_DEBUG ("Difference = " << expLifetime.GetSeconds () - actualLifetime.GetSeconds () << "s");
+  NS_LOG_DEBUG ("Expected lifetime = " << expLifetime.As (Time::S));
+  NS_LOG_DEBUG ("Actual lifetime = " << actualLifetime.As (Time::S));
+  NS_LOG_DEBUG ("Difference = " << (expLifetime - actualLifetime).As (Time::S));
 
   Simulator::Destroy ();
 
   // error tolerance = 120s
-  if ((actualLifetime.GetSeconds ()) > (expLifetime.GetSeconds ()) + (120) ||
-      (actualLifetime.GetSeconds ()) < (expLifetime.GetSeconds ()) - (120))
+  if (Abs (actualLifetime - expLifetime)  > Seconds (120))
     {
       std::cerr << "VariableLoadTest: Incorrect lifetime." << std::endl;
       return true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/energy/model/basic-energy-harvester.cc ns-3.33/src/energy/model/basic-energy-harvester.cc
--- ns-3.32/src/energy/model/basic-energy-harvester.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/energy/model/basic-energy-harvester.cc	2021-01-09 10:19:22.000000000 -0800
@@ -110,8 +110,8 @@
 BasicEnergyHarvester::UpdateHarvestedPower (void)
 {
   NS_LOG_FUNCTION (this);
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                << "s BasicEnergyHarvester(" << GetNode ()->GetId () << "): Updating harvesting power.");
+  NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                << " BasicEnergyHarvester(" << GetNode ()->GetId () << "): Updating harvesting power.");
 
   Time duration = Simulator::Now () - m_lastHarvestingUpdateTime;
 
@@ -169,8 +169,8 @@
 
   m_harvestedPower = m_harvestablePower->GetValue ();
 
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                << "s BasicEnergyHarvester:Harvested energy = " << m_harvestedPower);
+  NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                << " BasicEnergyHarvester:Harvested energy = " << m_harvestedPower);
 }
 
 double
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/energy/model/basic-energy-source.cc ns-3.33/src/energy/model/basic-energy-source.cc
--- ns-3.32/src/energy/model/basic-energy-source.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/energy/model/basic-energy-source.cc	2021-01-09 10:19:22.000000000 -0800
@@ -224,7 +224,7 @@
   Time duration = Simulator::Now () - m_lastUpdateTime;
   NS_ASSERT (duration.IsPositive ());
   // energy = current * voltage * time
-  double energyToDecreaseJ = (totalCurrentA * m_supplyVoltageV * duration.GetNanoSeconds ()) / 1e9;
+  double energyToDecreaseJ = (totalCurrentA * m_supplyVoltageV * duration).GetSeconds ();
   NS_ASSERT (m_remainingEnergyJ >= energyToDecreaseJ);
   m_remainingEnergyJ -= energyToDecreaseJ;
   NS_LOG_DEBUG ("BasicEnergySource:Remaining energy = " << m_remainingEnergyJ);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/energy/model/li-ion-energy-source.cc ns-3.33/src/energy/model/li-ion-energy-source.cc
--- ns-3.32/src/energy/model/li-ion-energy-source.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/energy/model/li-ion-energy-source.cc	2021-01-09 10:19:22.000000000 -0800
@@ -277,7 +277,7 @@
   // energy = current * voltage * time
   double energyToDecreaseJ = totalCurrentA * m_supplyVoltageV * duration.GetSeconds ();
 
-  if (m_remainingEnergyJ < energyToDecreaseJ) 
+  if (m_remainingEnergyJ < energyToDecreaseJ)
     {
       m_remainingEnergyJ = 0; // energy never goes below 0
     } 
@@ -286,7 +286,7 @@
       m_remainingEnergyJ -= energyToDecreaseJ;
     }  
 
-  m_drainedCapacity += (totalCurrentA * duration.GetSeconds () / 3600);
+  m_drainedCapacity += (totalCurrentA * duration).GetHours ();
   // update the supply voltage
   m_supplyVoltageV = GetVoltage (totalCurrentA);
   NS_LOG_DEBUG ("LiIonEnergySource:Remaining energy = " << m_remainingEnergyJ);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/energy/model/rv-battery-model.cc ns-3.33/src/energy/model/rv-battery-model.cc
--- ns-3.32/src/energy/model/rv-battery-model.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/energy/model/rv-battery-model.cc	2021-01-09 10:19:22.000000000 -0800
@@ -163,7 +163,7 @@
   double calculatedAlpha = Discharge (currentLoad, Simulator::Now ());
 
   NS_LOG_DEBUG ("RvBatteryModel:Calculated alpha = " << calculatedAlpha <<
-                " time = " << Simulator::Now ().GetSeconds ());
+                " time = " << Simulator::Now ().As (Time::S));
 
   // calculate battery level
   m_batteryLevel = 1 - (calculatedAlpha / m_alpha);
@@ -369,9 +369,9 @@
   NS_LOG_FUNCTION (this << t << sk << sk_1 << beta);
 
   // everything is in minutes
-  double firstDelta = (t.GetSeconds () - sk.GetSeconds ()) / 60;
-  double secondDelta = (t.GetSeconds () - sk_1.GetSeconds ()) / 60;
-  double delta = (sk.GetSeconds () - sk_1.GetSeconds ()) / 60;
+  double firstDelta = (t - sk).GetMinutes ();
+  double secondDelta = (t - sk_1).GetMinutes ();
+  double delta = (sk - sk_1).GetMinutes ();
 
   double sum = 0.0;
   for (int m = 1; m <= m_numOfTerms; m++)
